/**
 * @file charge.c
 * @author Tanguy Cavagna (tanguy.cavagna@etu.hesge.ch)
 * @brief Chrage library
 * @version 0.1
 * @date 2021-07-12
 * 
 * @copyright Copyright (c) 2021
 * 
 */
#include "draw/draw.h"
#include "vector/vector.h"
#include "utils.h"
#include "charge.h"

bool compute_e(charge_t c, vec2 p, double eps, vec2 *e) {
}

bool compute_total_normalized_e(charge_t *charges, int num_charges, vec2 p, double eps, vec2 *e) {
}

bool draw_field_line(struct gfx_context_t *ctxt, charge_t *charges, int num_charges, double dx, vec2 pos0, double x0, double x1, double y0, double y1) {
}

void draw_charges(struct gfx_context_t *ctxt, charge_t *charges, int num_charges, double x0, double x1, double y0, double y1) {
    // Center coordinates
    coordinates_t c;

    // Charges coordinates
    coordinates_t ch0;
    coordinates_t ch1;

    int radius = 25;
    int chargePadding = 10;

    // Draw charges
    for (int i = 0; i < num_charges; i++) {
        coordinates_t chCoord = position_to_coordinates(ctxt->width, ctxt->height, x0, x1, y0, y1, charges[i].pos);

        // Draw sign according to charge value
        if (charges[i].q < 0) {
            gfx_draw_line(ctxt, coordinates_create(chCoord.row, chCoord.column - chargePadding), coordinates_create(chCoord.row, chCoord.column + chargePadding), COLOR_BLUE);
        } else {
            gfx_draw_line(ctxt, coordinates_create(chCoord.row, chCoord.column - chargePadding), coordinates_create(chCoord.row, chCoord.column + chargePadding), COLOR_RED);
            gfx_draw_line(ctxt, coordinates_create(chCoord.row - chargePadding, chCoord.column), coordinates_create(chCoord.row + chargePadding, chCoord.column), COLOR_RED);
        }

        gfx_draw_circle(ctxt, chCoord, radius, charges[i].q < 0 ? COLOR_BLUE : COLOR_RED);
    }
}

void generate_points(vec2 points[], int nb_points) {
    double x = 0;
    double y = 0;

    for (int i = 0; i < nb_points; i++) {
        x = rand_one();
        y = rand_one();

        points[i] = init_vector(x, y);
    }
}