/**
 * @file test.c
 * @author Tanguy Cavagna (tanguy.cavagna@etu.hesge.ch)
 * @brief Test file for the draw functions
 * @version 0.1
 * @date 2021-07-12
 * 
 * @copyright Copyright (c) 2021
 * 
 */
#include <stdlib.h>
#include "../gfx/gfx.h"
#include "draw.h"

int main(void) {
    const int WINDOW_WIDTH = 100;
    const int WINDOW_HEIGHT = 100;

    struct gfx_context_t *ctxt = gfx_create("draw", WINDOW_WIDTH, WINDOW_HEIGHT);

    if (!ctxt) {
        fprintf(stderr, "Graphics initialization failed !\n");
        return EXIT_FAILURE;
    }

    coordinates_t p0 = {50, 50};
    coordinates_t p1 = {62, 72};
    coordinates_t p2 = {72, 62};
    coordinates_t p3 = {75, 50};
    coordinates_t p4 = {50, 75};
    coordinates_t p5 = {36, 72};
    coordinates_t p6 = {28, 62};
    coordinates_t p7 = {25, 50};
    coordinates_t p8 = {28, 38};
    coordinates_t p9 = {37, 28};
    coordinates_t p10 = {50, 25};
    coordinates_t p11 = {62, 28};
    coordinates_t p12 = {72, 37};

    gfx_draw_line(ctxt, p0, p3, COLOR_WHITE);
    gfx_draw_line(ctxt, p0, p2, COLOR_WHITE);
    gfx_draw_line(ctxt, p0, p1, COLOR_WHITE);
    gfx_draw_line(ctxt, p0, p4, COLOR_WHITE);

    gfx_draw_line(ctxt, p0, p5, COLOR_WHITE);
    gfx_draw_line(ctxt, p0, p6, COLOR_WHITE);
    gfx_draw_line(ctxt, p0, p7, COLOR_WHITE);
    gfx_draw_line(ctxt, p0, p8, COLOR_WHITE);

    gfx_draw_line(ctxt, p0, p9, COLOR_WHITE);
    gfx_draw_line(ctxt, p0, p10, COLOR_WHITE);
    gfx_draw_line(ctxt, p0, p11, COLOR_WHITE);
    gfx_draw_line(ctxt, p0, p12, COLOR_WHITE);

    while (gfx_keypressed() != SDLK_ESCAPE){
        gfx_present(ctxt);
    }

    gfx_destroy(ctxt);

    return EXIT_SUCCESS;
}